{#
 # This file is part of the DATAtourisme project.
 # @author Conjecto <contact@conjecto.com>
 # 2022
 # SPDX-License-Identifier: GPL-3.0-or-later
 # For the full copyright and license information, please view the LICENSE file that was distributed with this source code.
 #}

{% extends 'layout.twig' %}

{% if title %}
  {% block title %}
    {% if title.label is defined %}{{ title.label | clean_literal }}{% endif %}
  {% endblock %}
{% endif %}

{% block type %}
  {% for type in types %}
    {% if loop.index == 1 %}<br/>{% endif %}
    {% if type.label %}
      <small class="no-padding" title="{{ type.uri }}">{{ type.label }}</small>
      {% if loop.index < types|length %}&nbsp;{% endif %}
    {% endif %}
  {% endfor %}
{% endblock %}

{% block content %}
  <section class="content-header">

    {# Title #}
    {% if title %}
      <h1>
        <span title="{{ title.uri }}">{{ title.label | clean_literal }}</span>
        {% if has_fallbacked %}<span class="label label-danger">Obsolète</span>{% endif %}
        {{ block('type') }}
      </h1>
    {% else %}
      <h1>
        <span title="{{ uri.long }}">{{ uri.short }}</span>
        {{ block('type') }}
      </h1>
    {% endif %}
  </section>

  <section class="content">
    <div class="row">
      <div class="col-md-8">

        {# Description #}
        {% if description %}
          <div class="box no-border">
            <div class="box-body">
              <p class="m-0">{{ description | format_literal }}</p>
            </div>
          </div>
        {% endif %}

        {# Sections #}
        {% if sections %}
          {% for section in sections %}
            <div class="box no-border">
              <div class="box-header with-border">
                <h3 class="box-title" title="{{ section.uri }}">
                    {{ section.label }} {{ loop.index > 1 ? "<small>(est également)</small>" : "" }}
                </h3>
                <!-- /.box-tools -->
              </div>
              <!-- /.box-header -->
              <div class="box-body p-0">
                <div class="list-group no-margin">
                  {% for key, property in section.properties %}
                    <div class="list-group-item">
                      <div class="row">
                        <div class="col-sm-6 p-l-10 p-r-10">
                          <strong title="{{ property.uri }}">{{ property.label }}</strong>
                          {% if property.comment is defined %}
                            <br/><small class="text-muted">{{ property.comment ?: "" }}</small>
                          {% endif %}
                        </div>
                        <div class="col-sm-6 p-l-10 p-r-10">
                          {% set values = property.values %}
                          {% for value in values %}

                            <div{% if values | length > 1 %} class="prop-list list-group-item{% if loop.first %} no-border{% endif %}"{% endif %}>

                              {# Handling literal #}
                              {% if not is_resource(value) %}
                                {% if is_linkable(value) %}
                                  <a href="{{ value }}">{{ value }}</a>
                                {% elseif is_emailable(value) %}
                                  <a href="mailto:{{ value }}">{{ value }}</a>
                                {% else %}
                                  {{ value | format_literal | format_language }}
                                {% endif %}

                              {# Handling resource #}
                              {% else %}

                                {# Does ontology provide a label for this resource? #}
                                {% set onto_label = value.label('fr', true) %}
                                {% if onto_label %}
                                  <span title="{{ value.uri }}">
                                    {{ onto_label | format_literal }}
                                  </span>

                                {# Is this the mother resource? #}
                                {% elseif value.uri == uri.long %}
                                  <a href="{{ value.uri | datapathize }}">{{ title ? title.label : uri.short }}</a>

                                {# Does request provide a label for this resource? #}
                                {% else %}
                                  {% set res_label =
                                    value.literal(constant('App\\Supplier\\RDF\\RDF::MAIN_LABEL_URI'), 'fr')
                                  %}
                                  <a href="{{ value.uri | datapathize }}">
                                    {{ res_label ? res_label | format_literal | raw : value.uri | shorten }}
                                  </a>
                                {% endif %}
                              {% endif %}

                              {% if not loop.last %}<br/>{% endif %}

                            </div>
                          {% endfor %}
                        </div>
                      </div>
                    </div>
                  {% endfor %}
                </div>
              </div>
            </div>
          {% endfor %}
        {% endif %}

        {# Undescribed properties #}
        {% if undescribed is defined and undescribed is not empty %}
          <div class="box no-border">
            <div class="box-header with-border">
              <h3 class="box-title">Autres propriétés <small>(non décrites ou non classées)</small></h3>
              <!-- /.box-tools -->
            </div>
            <!-- /.box-header -->
            <div class="box-body p-0">
              <div class="list-group no-margin">
                {% for property in undescribed %}
                  <div class="list-group-item">
                    <div class="row">
                      <div class="col-sm-6 p-l-10 p-r-10">
                        <strong title="{{ property.uri }}">
                          {{ find_class_label(property.uri) ?: property.uri | shorten }}
                        </strong>
                        <br/>
                        <small class="text-muted">{{ find_class_comment(property.uri) ?: property.uri }}</small>
                      </div>
                      <div class="col-sm-6 p-l-10 p-r-10 list-group">
                        {% set values = property.allValues %}
                        {% for value in values %}

                          <div{% if values | length > 1 %} class="prop-list list-group-item{% if loop.first %} no-border{% endif %}"{% endif %}>
                            {# Handling literal #}
                            {% if is_string(value) %}
                              {% if is_linkable(value) %}
                                <a href="{{ value }}">{{ value }}</a>
                              {% elseif is_emailable(value) %}
                                <a href="mailto:{{ value }}">{{ value }}</a>
                              {% else %}
                                {{ value | format_literal | format_language }}
                              {% endif %}

                            {# Handling RDFResource #}
                            {% else %}
                              <a href="{{ value.uri | datapathize }}">{{ value.uri | shorten }}</a>
                            {% endif %}
                            {% if not loop.last %}<br/>{% endif %}
                          </div>
                        {% endfor %}
                      </div>
                    </div>
                  </div>
                {% endfor %}
              </div>
            </div>
          </div>
        {% endif %}

        {# References (async content) #}
        {% if allow_refs %}
          <div class="box no-border">
            <div class="box-header with-border">
              <h3 class="box-title">Références</h3>
              <!-- /.box-tools -->
            </div>
            <!-- /.box-header -->
            <div id="references"
                 data-path="{{ url('references', {uri: str_replace(data_path, '', uri.long),
                                                  res_label: title.label is defined ? title.label : uri.short }) }}"
                 class="box-body p-0"
            >
              {# AJAX CALL #}
            </div>
          </div>
        {% endif %}

      </div>

      {# Widgets #}
      <div class="col-md-4">
        {% for widget in widgets %}
          {{ widget.getTemplate() | raw }} {# We have full control over template, making Raw safe here #}
        {% endfor %}
        <div class="box box-primary box-solid">
          <div class="box-header with-border">
            <h4 class="box-title">
                <span class="fa fa-download"></span>&nbsp;Télécharger cette donnée
            </h4>
            <!-- /.box-tools -->
          </div>
          <!-- /.box-header -->
          <div class="box-body">
            <ul class="list-unstyled">
              <li>
                  Format RDF :
                  <a href="?format=rdf">RDF/XML</a>,
                  <a href="?format=nt">N-Triples</a>,
                  <a href="?format=ttl">Turtle</a>
              </li>
              <li>Format JSON-LD :
                  <a href="?format=jsonld">JSON-LD</a>
              </li>
            </ul>
          </div>
          <!-- /.box-body -->
        </div>

      </div>
    </div>
  </section>
{% endblock %}